/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src-admin/admin/AttributeEditor.js":
/*!********************************************!*\
  !*** ./src-admin/admin/AttributeEditor.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


const AttributeEditor = ({
  modal,
  setModal,
  classPrefix = "attribute"
}) => {
  const [selectedAttribute, setSelectedAttribute] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)("custom_attribute");
  const handleAttributeSelect = e => {
    setSelectedAttribute(e.target.value);
  };
  const addSelectedAttribute = () => {
    if (!selectedAttribute) {
      alert("Please select a valid attribute");
      return;
    }

    // Check if the selected attribute is a custom attribute
    const isCustomAttribute = selectedAttribute === "custom_attribute";

    // Check if selectedAttribute exists in wp_ajax.attribute_taxonomies
    const selectedTaxonomyData = wp_ajax.attribute_taxonomies[selectedAttribute];
    if (!isCustomAttribute && !selectedTaxonomyData) {
      alert("Invalid attribute selected");
      return;
    }
    const attributeData = isCustomAttribute ? {
      label: "Custom Attribute",
      values: "",
      istax: "no"
    } : {
      label: selectedTaxonomyData.attribute.attribute_label,
      all_attirbute: selectedTaxonomyData.values,
      istax: "yes",
      values: []
    };
    setModal(prevModal => ({
      ...prevModal,
      data: {
        ...prevModal.data,
        [isCustomAttribute ? `custom_attribute_${Date.now()}` : selectedAttribute]: attributeData
      }
    }));
  };
  const toggleAttribute = (key, termId) => {
    setModal(prevModal => {
      const updatedData = {
        ...prevModal.data
      };
      const selectedTermIds = updatedData[key].values || [];
      if (selectedTermIds.includes(termId)) {
        updatedData[key].values = selectedTermIds.filter(id => id !== termId);
      } else {
        updatedData[key].values = [...selectedTermIds, termId];
      }
      return {
        ...prevModal,
        data: updatedData
      };
    });
  };
  const handleAttributeChange = (key, newValue) => {
    setModal(prevModal => ({
      ...prevModal,
      data: {
        ...prevModal.data,
        [key]: {
          ...prevModal.data[key],
          values: newValue
        }
      }
    }));
  };
  const handleLabelChange = (key, newLabel) => {
    setModal(prevModal => ({
      ...prevModal,
      data: {
        ...prevModal.data,
        [key]: {
          ...prevModal.data[key],
          label: newLabel
        }
      }
    }));
  };
  const deleteAttribute = attrKey => {
    setModal(prevModal => {
      const updatedData = {
        ...prevModal.data
      };
      delete updatedData[attrKey]; // Remove the attribute
      return {
        ...prevModal,
        data: updatedData
      };
    });
  };
  const renderCheckbox = (label, stateKey, key, attribute) => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
    type: "checkbox",
    checked: attribute[stateKey] === "yes",
    onChange: () => setModal(prevModal => ({
      ...prevModal,
      data: {
        ...prevModal.data,
        [key]: {
          ...prevModal.data[key],
          [stateKey]: attribute[stateKey] === "yes" ? "no" : "yes"
        }
      }
    }))
  }), label);
  const getAttributeRowClass = key => `${classPrefix}-${key}`;
  return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "add-attribute-dropdown"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("select", {
    value: selectedAttribute,
    onChange: handleAttributeSelect,
    className: "attribute-dropdown"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
    value: "custom_attribute"
  }, "Custom Attribute"), Object.entries(wp_ajax.attribute_taxonomies).map(([key, attributeData]) => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
    key: key,
    value: attributeData.attribute_key
  }, attributeData.attribute.attribute_label))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("button", {
    className: "add-attribute-button",
    onClick: addSelectedAttribute
  }, "Add Attribute")), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("table", {
    className: "attribute-editor-table"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("thead", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", null, "Attribute Name"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", null, "Values"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", null, "Visible"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", null, "Variation"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", null, "Actions"))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tbody", null, Object.entries(modal.data).map(([key, attribute], index) => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", {
    key: index,
    className: getAttributeRowClass(key)
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, attribute.istax === "no" ? (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
    type: "text",
    value: attribute.label,
    onChange: e => handleLabelChange(key, e.target.value),
    className: "attribute-label-input",
    placeholder: "Enter label"
  }) : (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("strong", null, attribute.label)), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, attribute.istax === "yes" ? Array.isArray(attribute.all_attirbute) ? attribute.all_attirbute.map((attr, attrIndex) => {
    const isChecked = (attribute.values || []).includes(attr.term_id);
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      key: attrIndex,
      className: "attribute-checkbox"
    }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
      type: "checkbox",
      checked: isChecked,
      onChange: () => toggleAttribute(key, attr.term_id)
    }), attr.name);
  }) : (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("p", null, "No attributes available") : (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
    type: "text",
    placeholder: "Enter value",
    value: attribute.values || "",
    onChange: e => handleAttributeChange(key, e.target.value),
    className: "attribute-input"
  })), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, renderCheckbox("", "visible", key, attribute)), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, renderCheckbox("", "variation", key, attribute)), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("button", {
    className: "attribute-delete-button",
    onClick: () => deleteAttribute(key)
  }, "Delete")))))));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (AttributeEditor);

/***/ }),

/***/ "./src-admin/admin/DefaultAttributeEditor.js":
/*!***************************************************!*\
  !*** ./src-admin/admin/DefaultAttributeEditor.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


const DefaultAttributeEditor = ({
  modal,
  setModal
}) => {
  // Handles when an attribute value is selected from the dropdown
  const handleSelectChange = (key, selectedValue) => {
    setModal(prevModal => ({
      ...prevModal,
      data: {
        ...prevModal.data,
        [key]: {
          ...prevModal.data[key],
          selected: selectedValue
        }
      }
    }));
  };
  return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "attribute-editor"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("table", {
    className: "attribute-editor-table"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("thead", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", null, "Attribute Name"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", null, "Values"))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tbody", null, Object.entries(modal.data).map(([key, attribute], index) => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", {
    key: index
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("strong", null, attribute.label)), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, attribute.istax === "yes" && Array.isArray(attribute.values) ? (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("select", {
    value: attribute.selected || "",
    onChange: e => handleSelectChange(key, e.target.value)
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
    value: ""
  }, "Select a value"), attribute.values.map((value, valueIndex) => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
    key: valueIndex,
    value: value.slug
  }, value.name))) : attribute.istax === "no" && Array.isArray(attribute.values) ? (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("select", {
    value: attribute.selected || "",
    onChange: e => handleSelectChange(key, e.target.value)
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
    value: ""
  }, "Select a value"), attribute.values.map((value, valueIndex) => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
    key: valueIndex,
    value: value
  }, value))) : (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("p", null, "No values available")))))));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (DefaultAttributeEditor);

/***/ }),

/***/ "./src-admin/admin/EditableTable.js":
/*!******************************************!*\
  !*** ./src-admin/admin/EditableTable.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _AttributeEditor__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./AttributeEditor */ "./src-admin/admin/AttributeEditor.js");
/* harmony import */ var _DefaultAttributeEditor__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./DefaultAttributeEditor */ "./src-admin/admin/DefaultAttributeEditor.js");






// EditableTable component for rendering a table with editable fields
const EditableTable = ({
  columns,
  data,
  updateMyData
}) => {
  const visibleColumns = columns.filter(col => col.isShow);
  const [modal, setModal] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)({
    isOpen: false,
    data: null,
    rowIndex: null,
    columnId: null,
    fieldType: null,
    options: []
  });
  const openModal = (rowIndex, columnId, value = "", fieldType, options = []) => {
    console.log(value);
    setModal({
      isOpen: true,
      data: value,
      rowIndex,
      columnId,
      fieldType,
      options
    });
  };
  const saveModalData = () => {
    updateMyData(modal.rowIndex, modal.columnId, modal.data);
    setModal(prev => ({
      ...prev,
      isOpen: false
    }));
  };
  const handleInputChange = (e, rowIndex, columnId) => {
    const {
      type,
      value,
      checked
    } = e.target;
    updateMyData(rowIndex, columnId, type === "checkbox" ? checked : value);
  };
  const handleCheckboxChange = option => {
    setModal(prev => ({
      ...prev,
      data: prev.data.includes(option) ? prev.data.filter(item => item !== option) : [...prev.data, option]
    }));
  };
  const openMediaUploader = (rowIndex, columnId, value, multiple = false) => {
    const mediaUploader = wp.media({
      title: multiple ? "Select or Upload Images" : "Select or Upload Image",
      button: {
        text: multiple ? "Use these images" : "Use this image"
      },
      multiple,
      library: {
        type: "image"
      }
    });
    mediaUploader.on("open", () => {
      if (value) {
        const selection = mediaUploader.state().get("selection");
        (Array.isArray(value) ? value : [value]).forEach(id => {
          const attachment = wp.media.attachment(id);
          attachment.fetch();
          selection.add(attachment);
        });
      }
    });
    mediaUploader.on("select", () => {
      const selectedImages = mediaUploader.state().get("selection").map(att => att.toJSON().id);
      updateMyData(rowIndex, columnId, multiple ? selectedImages : selectedImages[0]);
    });
    mediaUploader.open();
  };
  return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "editable-table-wrapper"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "editable-table"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("table", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("thead", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", null, visibleColumns.map(column => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", {
    key: column.accessor
  }, column.Header)))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tbody", null, data.map((row, rowIndex) => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", {
    key: rowIndex
  }, visibleColumns.map(column => {
    var _cellData$value, _cellData$hide;
    const cellData = row[column.accessor] || {}; // Ensure no undefined errors
    const value = (_cellData$value = cellData.value) !== null && _cellData$value !== void 0 ? _cellData$value : ""; // Default to empty string
    const hide = (_cellData$hide = cellData.hide) !== null && _cellData$hide !== void 0 ? _cellData$hide : "no";
    switch (column.inputType) {
      case "readonly":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
          type: "text",
          readOnly: true,
          value: value
        }));
      case "text":
      case "number":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, hide === "no" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
          type: column.inputType,
          value: value,
          onChange: e => handleInputChange(e, rowIndex, column.accessor)
        }));
      case "datetime-local":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, hide === "no" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
          type: column.inputType,
          value: value,
          onChange: e => handleInputChange(e, rowIndex, column.accessor)
        }));
      case "select":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, hide === "no" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("select", {
          value: value,
          onChange: e => handleInputChange(e, rowIndex, column.accessor)
        }, column.options.map(option => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
          key: option.value,
          value: option.value
        }, option.label))));
      case "checkbox":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, hide === "no" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
          type: "checkbox",
          checked: Boolean(value) // Ensure boolean value
          ,
          onChange: e => handleInputChange(e, rowIndex, column.accessor)
        }));
      case "multipleCheckbox":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, hide === "no" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
          variant: "secondary",
          onClick: () => openModal(rowIndex, column.accessor, value, "multipleCheckbox", column.options)
        }, "Edit"));
      case "editor":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, hide === "no" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
          variant: "secondary",
          onClick: () => openModal(rowIndex, column.accessor, value, "editor")
        }, "Edit"));
      case "image":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
          variant: "secondary",
          onClick: () => openMediaUploader(rowIndex, column.accessor, value, false) // Pass rowIndex and columnId
        }, "Upload Image"));
      case "gallery":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
          variant: "secondary",
          onClick: () => openMediaUploader(rowIndex, column.accessor, value, true) // Pass rowIndex and columnId
        }, "Upload Image"));
      case "attribute":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
          variant: "secondary",
          onClick: () => openModal(rowIndex, column.accessor, value, "attribute")
        }, "Edit Attirbute"));
      case "default_attribute":
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, hide === "no" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
          variant: "secondary",
          onClick: () => openModal(rowIndex, column.accessor, value, "default_attribute")
        }, "Edit Default Attirbute"));
      default:
        return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
          key: column.accessor
        }, value);
    }
  }))))), modal.isOpen && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Modal, {
    title: "Edit Content",
    onRequestClose: () => setModal(prev => ({
      ...prev,
      isOpen: false
    }))
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "modal-content"
  }, modal.fieldType === "editor" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("textarea", {
    value: modal.data,
    onChange: e => setModal(prev => ({
      ...prev,
      data: e.target.value
    })),
    style: {
      width: "100%",
      height: "150px"
    }
  })), modal.fieldType === "attribute" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_AttributeEditor__WEBPACK_IMPORTED_MODULE_2__["default"], {
    modal: modal,
    setModal: setModal
  }), modal.fieldType === "default_attribute" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_DefaultAttributeEditor__WEBPACK_IMPORTED_MODULE_3__["default"], {
    modal: modal,
    setModal: setModal
  }), modal.fieldType === "multipleCheckbox" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.__experimentalScrollable, {
    scrollDirection: "y",
    style: {
      height: 300
    }
  }, modal.options.map(opt => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    key: opt.value,
    style: {
      marginBottom: "5px"
    }
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
    type: "checkbox",
    value: opt.value,
    checked: modal.data.includes(opt.value),
    onChange: () => handleCheckboxChange(opt.value)
  }), opt.label)))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "modal-actions",
    style: {
      marginTop: "10px"
    }
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
    variant: "primary",
    onClick: saveModalData
  }, "Save"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
    variant: "secondary",
    onClick: () => setModal(prev => ({
      ...prev,
      isOpen: false
    }))
  }, "Cancel"))))));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (EditableTable);

/***/ }),

/***/ "./src-admin/admin/FilterModal.js":
/*!****************************************!*\
  !*** ./src-admin/admin/FilterModal.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var js_cookie__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! js-cookie */ "./node_modules/js-cookie/dist/js.cookie.mjs");



 // Import js-cookie

const FilterModal = ({
  filtersFields,
  isOpen,
  onClose,
  onApplyFilter
}) => {
  const [filters, setFilters] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)({});

  // Load filters from cookies when modal opens
  (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
    if (isOpen) {
      const savedFilters = js_cookie__WEBPACK_IMPORTED_MODULE_2__["default"].get('product_filters');
      if (savedFilters) {
        setFilters(JSON.parse(savedFilters));
      }
    }
  }, [isOpen]);
  const handleInputChange = (field, value) => {
    setFilters(prevFilters => ({
      ...prevFilters,
      [field]: value
    }));
  };
  const handleMultipleCheckboxChange = (field, value) => {
    setFilters(prevFilters => {
      const updatedValues = prevFilters[field] ? [...prevFilters[field]] : [];
      if (updatedValues.includes(value)) {
        return {
          ...prevFilters,
          [field]: updatedValues.filter(item => item !== value)
        };
      } else {
        return {
          ...prevFilters,
          [field]: [...updatedValues, value]
        };
      }
    });
  };
  const handleApplyFilter = () => {
    js_cookie__WEBPACK_IMPORTED_MODULE_2__["default"].set('product_filters', JSON.stringify(filters), {
      expires: 7
    }); // Store for 7 days
    onApplyFilter(filters);
  };
  console.log(filtersFields);
  return isOpen && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Modal, {
    title: "Filter Products",
    onRequestClose: onClose
  }, filtersFields.map(column => {
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      key: column.accessor,
      style: {
        marginBottom: '10px'
      }
    }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, column.title), (column.inputType === "text" || column.inputType === "number" || column.inputType === "datetime-local") && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
      type: column.inputType,
      value: filters[column.accessor] || "",
      onChange: e => handleInputChange(column.accessor, e.target.value)
    }), column.inputType === "select" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("select", {
      value: filters[column.accessor] || "",
      onChange: e => handleInputChange(column.accessor, e.target.value)
    }, column.options.map(option => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("option", {
      key: option.value,
      value: option.value
    }, option.label))), column.inputType === "checkbox" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
      type: "checkbox",
      checked: Boolean(filters[column.accessor]),
      onChange: e => handleInputChange(column.accessor, e.target.checked)
    }), column.inputType === "multipleCheckbox" && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.__experimentalScrollable, {
      scrollDirection: "y",
      style: {
        maxHeight: 300
      }
    }, column.options.map(option => (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      key: option.value
    }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("input", {
      type: "checkbox",
      checked: filters[column.accessor]?.includes(option.value) || false,
      onChange: () => handleMultipleCheckboxChange(column.accessor, option.value)
    }), option.label)))));
  }), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    style: {
      marginTop: '15px'
    }
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
    isPrimary: true,
    onClick: handleApplyFilter,
    style: {
      marginRight: '10px'
    }
  }, "Apply Filter"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
    onClick: onClose
  }, "Close")));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (FilterModal);

/***/ }),

/***/ "./src-admin/admin/SettingsModal.js":
/*!******************************************!*\
  !*** ./src-admin/admin/SettingsModal.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var js_cookie__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! js-cookie */ "./node_modules/js-cookie/dist/js.cookie.mjs");




const SettingsModal = ({
  columns,
  isOpen,
  onClose,
  onApplySetting
}) => {
  const [settings, setSettings] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)({});

  // Load settings from cookies when the modal opens
  (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
    if (isOpen) {
      const savedSettings = js_cookie__WEBPACK_IMPORTED_MODULE_2__["default"].get('admin_settings');
      if (savedSettings) {
        setSettings(JSON.parse(savedSettings));
      } else {
        // Initialize settings if no cookie exists (default: all columns selected)
        const initialSettings = columns.reduce((acc, col) => {
          acc[col.accessor] = true;
          return acc;
        }, {});
        setSettings(initialSettings);
      }
    }
  }, [isOpen, columns]);
  const handleChange = (key, value) => {
    setSettings(prev => ({
      ...prev,
      [key]: value
    }));
  };
  const handleSaveSettings = () => {
    js_cookie__WEBPACK_IMPORTED_MODULE_2__["default"].set('admin_settings', JSON.stringify(settings), {
      expires: 7
    }); // Store for 7 days
    console.log("Saved Settings:", settings);
    onClose();
    onApplySetting();
  };
  return isOpen && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Modal, {
    title: "Settings",
    onRequestClose: onClose
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("strong", null, "Show/Hide Columns")), columns.map(column => {
    var _settings$column$acce;
    return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.CheckboxControl, {
      key: column.accessor,
      label: column.Header // Display column title
      ,
      checked: (_settings$column$acce = settings[column.accessor]) !== null && _settings$column$acce !== void 0 ? _settings$column$acce : true // Default to true
      ,
      onChange: value => handleChange(column.accessor, value)
    });
  })), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    style: {
      marginTop: '15px'
    }
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
    isPrimary: true,
    onClick: handleSaveSettings,
    style: {
      marginRight: '10px'
    }
  }, "Save Settings"), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Button, {
    onClick: onClose
  }, "Close")));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (SettingsModal);

/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "React" ***!
  \************************/
/***/ ((module) => {

module.exports = window["React"];

/***/ }),

/***/ "@wordpress/components":
/*!************************************!*\
  !*** external ["wp","components"] ***!
  \************************************/
/***/ ((module) => {

module.exports = window["wp"]["components"];

/***/ }),

/***/ "@wordpress/dom-ready":
/*!**********************************!*\
  !*** external ["wp","domReady"] ***!
  \**********************************/
/***/ ((module) => {

module.exports = window["wp"]["domReady"];

/***/ }),

/***/ "@wordpress/element":
/*!*********************************!*\
  !*** external ["wp","element"] ***!
  \*********************************/
/***/ ((module) => {

module.exports = window["wp"]["element"];

/***/ }),

/***/ "./node_modules/js-cookie/dist/js.cookie.mjs":
/*!***************************************************!*\
  !*** ./node_modules/js-cookie/dist/js.cookie.mjs ***!
  \***************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ api)
/* harmony export */ });
/*! js-cookie v3.0.5 | MIT */
/* eslint-disable no-var */
function assign (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];
    for (var key in source) {
      target[key] = source[key];
    }
  }
  return target
}
/* eslint-enable no-var */

/* eslint-disable no-var */
var defaultConverter = {
  read: function (value) {
    if (value[0] === '"') {
      value = value.slice(1, -1);
    }
    return value.replace(/(%[\dA-F]{2})+/gi, decodeURIComponent)
  },
  write: function (value) {
    return encodeURIComponent(value).replace(
      /%(2[346BF]|3[AC-F]|40|5[BDE]|60|7[BCD])/g,
      decodeURIComponent
    )
  }
};
/* eslint-enable no-var */

/* eslint-disable no-var */

function init (converter, defaultAttributes) {
  function set (name, value, attributes) {
    if (typeof document === 'undefined') {
      return
    }

    attributes = assign({}, defaultAttributes, attributes);

    if (typeof attributes.expires === 'number') {
      attributes.expires = new Date(Date.now() + attributes.expires * 864e5);
    }
    if (attributes.expires) {
      attributes.expires = attributes.expires.toUTCString();
    }

    name = encodeURIComponent(name)
      .replace(/%(2[346B]|5E|60|7C)/g, decodeURIComponent)
      .replace(/[()]/g, escape);

    var stringifiedAttributes = '';
    for (var attributeName in attributes) {
      if (!attributes[attributeName]) {
        continue
      }

      stringifiedAttributes += '; ' + attributeName;

      if (attributes[attributeName] === true) {
        continue
      }

      // Considers RFC 6265 section 5.2:
      // ...
      // 3.  If the remaining unparsed-attributes contains a %x3B (";")
      //     character:
      // Consume the characters of the unparsed-attributes up to,
      // not including, the first %x3B (";") character.
      // ...
      stringifiedAttributes += '=' + attributes[attributeName].split(';')[0];
    }

    return (document.cookie =
      name + '=' + converter.write(value, name) + stringifiedAttributes)
  }

  function get (name) {
    if (typeof document === 'undefined' || (arguments.length && !name)) {
      return
    }

    // To prevent the for loop in the first place assign an empty array
    // in case there are no cookies at all.
    var cookies = document.cookie ? document.cookie.split('; ') : [];
    var jar = {};
    for (var i = 0; i < cookies.length; i++) {
      var parts = cookies[i].split('=');
      var value = parts.slice(1).join('=');

      try {
        var found = decodeURIComponent(parts[0]);
        jar[found] = converter.read(value, found);

        if (name === found) {
          break
        }
      } catch (e) {}
    }

    return name ? jar[name] : jar
  }

  return Object.create(
    {
      set,
      get,
      remove: function (name, attributes) {
        set(
          name,
          '',
          assign({}, attributes, {
            expires: -1
          })
        );
      },
      withAttributes: function (attributes) {
        return init(this.converter, assign({}, this.attributes, attributes))
      },
      withConverter: function (converter) {
        return init(assign({}, this.converter, converter), this.attributes)
      }
    },
    {
      attributes: { value: Object.freeze(defaultAttributes) },
      converter: { value: Object.freeze(converter) }
    }
  )
}

var api = init(defaultConverter, { path: '/' });
/* eslint-enable no-var */




/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry needs to be wrapped in an IIFE because it needs to be isolated against other modules in the chunk.
(() => {
/*!****************************!*\
  !*** ./src-admin/admin.js ***!
  \****************************/
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_dom_ready__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/dom-ready */ "@wordpress/dom-ready");
/* harmony import */ var _wordpress_dom_ready__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_dom_ready__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var js_cookie__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! js-cookie */ "./node_modules/js-cookie/dist/js.cookie.mjs");
/* harmony import */ var _admin_EditableTable__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./admin/EditableTable */ "./src-admin/admin/EditableTable.js");
/* harmony import */ var _admin_FilterModal__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./admin/FilterModal */ "./src-admin/admin/FilterModal.js");
/* harmony import */ var _admin_SettingsModal__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./admin/SettingsModal */ "./src-admin/admin/SettingsModal.js");









const AdminApp = () => {
  const [isLoading, setIsLoading] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [isSaving, setIsSaving] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [isFetchingNext, setIsFetchingNext] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [isFetchingPrev, setIsFetchingPrev] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [data, setData] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([]);
  const [columns, setColumns] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([]);
  const [filtersFields, setFiltersFields] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([]);
  const [currentPage, setCurrentPage] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(1);
  const [totalPages, setTotalPages] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(1);
  const [isFilterModalOpen, setIsFilterModalOpen] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [isSettingsModalOpen, setIsSettingsModalOpen] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
  const [filterCount, setFilterCount] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(0);
  const rowsPerPage = 10;
  const fetchData = page => {
    setIsLoading(true);
    const savedFilters = js_cookie__WEBPACK_IMPORTED_MODULE_4__["default"].get('product_filters');
    const filters = savedFilters ? JSON.parse(savedFilters) : null;
    const savedSettings = js_cookie__WEBPACK_IMPORTED_MODULE_4__["default"].get('admin_settings');
    const settings = savedSettings ? JSON.parse(savedSettings) : null;

    // Construct request data
    const requestData = {
      security: wp_ajax.nonce,
      page: page,
      per_page: rowsPerPage
    };

    // Only add filters if they exist
    if (filters) {
      requestData.filters = filters;
      const activeFilters = Object.values(filters).filter(value => value && value.length > 0).length;
      setFilterCount(activeFilters);
    } else {
      setFilterCount(0);
    }
    if (settings) {
      requestData.settings = settings;
    }
    console.log("settings", settings);
    return fetch(wp_ajax.getdata, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'X-WP-Nonce': wp_ajax.nonce
      },
      body: JSON.stringify(requestData)
    }).then(response => response.json()).then(responseData => {
      console.log('Fetched Data:', responseData);
      setData(responseData.data);
      setTotalPages(responseData.total_pages);
      setColumns(responseData.header);
      setFiltersFields(responseData.filter);
      setIsFetchingNext(false);
      setIsFetchingPrev(false);
      setIsLoading(false);
    }).catch(error => {
      console.error('Error fetching data:', error);
    });
  };
  (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
    fetchData(currentPage);
  }, [currentPage]);
  const [modifiedCells, setModifiedCells] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)([]);
  const updateMyData = (rowIndex, columnId, value) => {
    setData(oldData => oldData.map((row, index) => {
      if (index === rowIndex) {
        setModifiedCells(prev => {
          var _row$id$value;
          return [...prev.filter(cell => !(cell.rowIndex === rowIndex && cell.columnId === columnId)), {
            rowIndex,
            id: (_row$id$value = row.id?.value) !== null && _row$id$value !== void 0 ? _row$id$value : row.id,
            // Ensure `id` is a number
            columnId,
            value
          }];
        });
        return {
          ...row,
          [columnId]: {
            ...row[columnId],
            value
          } // Preserve structure
        };
      }
      return row;
    }));
  };
  const handleSave = () => {
    if (modifiedCells.length === 0) {
      alert('No changes to save.');
      return;
    }
    setIsSaving(true);
    const requestData = {
      security: wp_ajax.nonce,
      modifiedCells
    };
    fetch(wp_ajax.savedata, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'X-WP-Nonce': wp_ajax.nonce
      },
      body: JSON.stringify(requestData)
    }).then(response => response.json()).then(() => {
      setIsSaving(false);
      alert('Data saved successfully!');
      setModifiedCells([]); // Reset changes after saving
    }).catch(error => {
      setIsSaving(false);
      console.error('Error saving data:', error);
    });
  };
  const goToNextPage = () => {
    setIsFetchingNext(true);
    setCurrentPage(prev => Math.min(prev + 1, totalPages));
  };
  const goToPreviousPage = () => {
    setIsFetchingPrev(true);
    setCurrentPage(prev => Math.max(prev - 1, 1));
  };
  const applyFilter = filters => {
    console.log("filters", filters);
    setIsFilterModalOpen(false);
    fetchData(1);
  };
  return (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Panel, null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.PanelBody, null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "filterbar"
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Button, {
    isPrimary: true,
    onClick: () => setIsFilterModalOpen(true)
  }, "Filter ", filterCount > 0 && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("span", {
    className: "btncounter"
  }, filterCount))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Button, {
    isPrimary: true,
    onClick: () => setIsSettingsModalOpen(true)
  }, "Settings")), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Button, {
    isPrimary: true,
    disabled: modifiedCells.length === 0 || isSaving,
    onClick: handleSave
  }, isSaving ? (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Spinner, null) : (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, "Save Settings", modifiedCells.length > 0 && (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("span", {
    className: "btncounter"
  }, modifiedCells.length)))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", null, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Button, {
    isPrimary: true,
    onClick: () => window.open('https://www.codesmade.com/contact-us/', '_blank'),
    className: "supportbutton"
  }, "24/7 Support"))), isLoading ? (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Spinner, null) : (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_admin_EditableTable__WEBPACK_IMPORTED_MODULE_5__["default"], {
    columns: columns,
    data: data,
    updateMyData: updateMyData
  }), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    style: {
      display: 'flex',
      justifyContent: 'space-between',
      marginTop: '20px',
      marginBottom: '20px'
    }
  }, (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Button, {
    isPrimary: true,
    onClick: goToPreviousPage,
    disabled: currentPage === 1 || isFetchingPrev
  }, isFetchingPrev ? (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Spinner, null) : 'Previous'), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)("span", null, "Page ", currentPage, " of ", totalPages), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Button, {
    isPrimary: true,
    onClick: goToNextPage,
    disabled: currentPage === totalPages || isFetchingNext
  }, isFetchingNext ? (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_3__.Spinner, null) : 'Next'))), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_admin_FilterModal__WEBPACK_IMPORTED_MODULE_6__["default"], {
    filtersFields: filtersFields,
    isOpen: isFilterModalOpen,
    onClose: () => setIsFilterModalOpen(false),
    onApplyFilter: applyFilter
  }), (0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(_admin_SettingsModal__WEBPACK_IMPORTED_MODULE_7__["default"], {
    columns: columns,
    isOpen: isSettingsModalOpen,
    onClose: () => {
      setIsSettingsModalOpen(false);
    },
    onApplySetting: () => {
      fetchData(1); // Refresh data when settings modal is closed
    }
  }));
};
_wordpress_dom_ready__WEBPACK_IMPORTED_MODULE_1___default()(() => {
  const root = (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_2__.createRoot)(document.getElementById('gmbpu-admin-root'));
  root.render((0,react__WEBPACK_IMPORTED_MODULE_0__.createElement)(AdminApp, null));
});
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (AdminApp);
})();

/******/ })()
;
//# sourceMappingURL=admin.js.map