<?php
/*
* Plugin Name: Bulk Edit Product For Woocommerce
* Description: Products Bulk Editor allows you to efficiently edit WooCommerce products with ease, enabling quick updates to product details and the ability to create multiple products in bulk.
 * Version: 1.0
 * Author: Gravity Master
 * License: GPLv2 or later
 * Text Domain: bulk-edit-product-for-woocommerce
*/
if ( ! defined( 'ABSPATH' ) ) {
    die();
}

/* All constants should be defined in this file. */
if ( ! defined( 'GMBPU_PREFIX' ) ) {
    define( 'GMBPU_PREFIX', 'gmbpu' );
}
if ( ! defined( 'GMBPU_PLUGINDIR' ) ) {
    define( 'GMBPU_PLUGINDIR', plugin_dir_path( __FILE__ ) );
}
if ( ! defined( 'GMBPU_PLUGINBASENAME' ) ) {
    define( 'GMBPU_PLUGINBASENAME', plugin_basename( __FILE__ ) );
}
if ( ! defined( 'GMBPU_PLUGINURL' ) ) {
    define( 'GMBPU_PLUGINURL', plugin_dir_url( __FILE__ ) );
}

/* Auto-load all the necessary classes. */
if( ! function_exists( 'gmbpu_class_auto_loader' ) ) {
    
    function gmbpu_class_auto_loader( $class ) {
        
        $includes = GMBPU_PLUGINDIR . 'includes/' . $class . '.php';
        
        if( is_file( $includes ) && ! class_exists( $class ) ) {
            include_once( $includes );
            return;
        }
        
    }
}
spl_autoload_register('gmbpu_class_auto_loader');
new GMBPU_Cron();
new GMBPU_Admin();
new GMBPU_API();




