<?php

class GMBPU_API {
    public $GMBPU_Table_Value_Save;
    public $GMBPU_Table_Query;
    public function __construct() {
        add_action('rest_api_init', array($this,'GMBPU_rest_api_init'));
        $this->GMBPU_Table_Query = new GMBPU_Table_Query();
        $this->GMBPU_Table_Value_Save = new GMBPU_Table_Value_Save();
    }

    public function GMBPU_rest_api_init() {
        register_rest_route('gmbpu/v1', '/getproducts', array(
            'methods' => 'POST',
            'callback' => array($this,'GMBPU_getproducts'),
            'permission_callback' => array($this, 'GMBPU_permission_callback')
        ));
        register_rest_route('gmbpu/v1', '/saveproducts', array(
            'methods' => 'POST',
            'callback' => array($this,'GMBPU_saveproducts'),
            'permission_callback' => array($this, 'GMBPU_permission_callback')
        ));
        register_rest_route('gmbpu/v1', '/savefilter', array(
            'methods' => 'POST',
            'callback' => array($this,'GMBPU_savefilter'),
            'permission_callback' => array($this, 'GMBPU_permission_callback')
        ));
        
    }

    public function GMBPU_permission_callback($request) {
        return current_user_can('manage_options');
    }
    
    public function GMBPU_saveproducts(WP_REST_Request $request) {
         // Get nonce from request headers
        $nonce = $request->get_header('X-WP-Nonce');

        // Verify nonce
        if ( ! wp_verify_nonce( $nonce, 'wp_rest' ) ) {
            return new WP_REST_Response(array(
            'success' => false,
            'message' => 'Invalid nonce',
        ), 403); // Invalid nonce error
        }

        // Get form data from the request body (JSON)
        $data = $request->get_json_params();
        foreach($data['modifiedCells'] as $key=>$val){
            $this->GMBPU_Table_Value_Save->GMBPU_Value_Save($val);
            
        }
         $data = array(
            'status' => 'success',
            'message' => 'API call successful',
        );
        
        wp_send_json($data);
    }
    public function GMBPU_savefilter(WP_REST_Request $request) {
         // Get nonce from request headers
        $nonce = $request->get_header('X-WP-Nonce');

        // Verify nonce
        if ( ! wp_verify_nonce( $nonce, 'wp_rest' ) ) {
            return new WP_REST_Response(array(
            'success' => false,
            'message' => 'Invalid nonce',
        ), 403); // Invalid nonce error
        }

        // Get form data from the request body (JSON)
        $data = $request->get_json_params();
        foreach($data['modifiedCells'] as $key=>$val){
            $this->GMBPU_Table_Value_Save->GMBPU_Value_Save_Filter($val);
            
        }
         $data = array(
            'status' => 'success',
            'message' => 'API call successful',
        );
        
        wp_send_json($data);
    }
    
    public function GMBPU_getproducts(WP_REST_Request $request) {

         // Get nonce from request headers
        $nonce = $request->get_header('X-WP-Nonce');

        // Verify nonce
        if ( ! wp_verify_nonce( $nonce, 'wp_rest' ) ) {
            return new WP_REST_Response(array(
            'success' => false,
            'message' => 'Invalid nonce',
        ), 403); // Invalid nonce error
        }

        // Get form data from the request body (JSON)
        $data = $request->get_json_params();

      
        $page = isset($_GET['page']) ? max(1, intval($_GET['page'])) : 1;

       
         
        $data = $this->GMBPU_Table_Query->GMBPU_Table_Query_Data($data,$page);

        
        
        wp_send_json($data);
    }

   

   
}
