<?php
/**
* This class is loaded on the back-end since its main job is
* to display the Admin to box.
*/
class GMBPU_Admin {
	
	public function __construct () {
		add_action('admin_enqueue_scripts', array($this,'GMBPU_enqueue_admin'));

		add_action('admin_menu', array($this,'GMBPU_admin_menu'));
	}

	public function GMBPU_enqueue_admin($hook){
		if($hook=='toplevel_page_bulk-edit-product'){
			wp_enqueue_media();
			wp_enqueue_style('wp-components');
			 wp_register_script(
	            'gmbpu-react-admin',
	            GMBPU_PLUGINURL.'/build/admin/admin.js', // Adjust the path if necessary
		        ['wp-element','wp-dom-ready','wp-components'], // Ensure this depends on WordPress's React
		        '1.0',
		        true

		        );
		         
			 	$attribute_taxonomies = wc_get_attribute_taxonomies();
				$taxonomy_terms = array();

				if ($attribute_taxonomies) :
				    foreach ($attribute_taxonomies as $tax) :
				        if (taxonomy_exists(wc_attribute_taxonomy_name($tax->attribute_name))) :
				        	$taxonomy_terms[wc_attribute_taxonomy_name($tax->attribute_name)]['attribute'] = $tax;
				        	$taxonomy_terms[wc_attribute_taxonomy_name($tax->attribute_name)]['attribute_key'] = wc_attribute_taxonomy_name($tax->attribute_name);
				            $taxonomy_terms[wc_attribute_taxonomy_name($tax->attribute_name)]['values'] = get_terms(wc_attribute_taxonomy_name($tax->attribute_name), 'orderby=name&hide_empty=0');
				        endif;
				    endforeach;
				endif;

		        wp_localize_script('gmbpu-react-admin', 'wp_ajax', [
		            'nonce' => wp_create_nonce('wp_rest'), // Nonce for security in the REST API
		            'ajax_url' => admin_url('admin-ajax.php'),
		            'getdata' => rest_url('gmbpu/v1/getproducts'),
		            'savedata' => rest_url('gmbpu/v1/saveproducts'),
		            'savefilter' => rest_url('gmbpu/v1/savefilter'),
		            'attribute_taxonomies' => $taxonomy_terms,
		            'site_url' => get_site_url()
		        ]);

				wp_enqueue_script('gmbpu-react-admin');

			    wp_enqueue_style(
			            'gmbpu-react-admin-style',
			            GMBPU_PLUGINURL.'/css/admin.css',
			            array(),
			            1,
			        );
		}
	}

	public function GMBPU_admin_menu(){
		add_menu_page(
	        'Bulk Edit Product',
	        'Bulk Edit Product',
	        'manage_options',
	        'bulk-edit-product',
	        array($this,'GMBPU_render_admin_page'),
	        'dashicons-admin-site',
	        100
	    );
	}

	public function GMBPU_render_admin_page(){
		 echo '<div id="gmbpu-admin-root"></div>';
	}
}
