<?php
/**
* This class is loaded on the back-end since its main job is
* to display the Admin to box.
*/
class GMBPU_Table_Value {
	
	 public function GMBPU_Value($product_id,$post){

        global $GMBPU_GLOBAL;
       
        $product = wc_get_product($product_id);
        // Get all attributes
        $attributes = $product->get_attributes();
        $default_attributes = $product->get_default_attributes();

        // Prepare an array to store formatted attributes
        $attributes_data = [];
        $defalut_attributes_data = [];

        foreach ($attributes as $attribute_name => $attribute) {
            if ($attribute->is_taxonomy()) {
                // If attribute is a taxonomy (like "pa_color", "pa_size")
                $terms = wc_get_product_terms($product->get_id(), $attribute_name);
                $attributes_data[$attribute_name]['istax'] = 'yes';
                $attribute_label = wc_attribute_label($attribute_name, $product);
                $attributes_data[$attribute_name]['label'] = $attribute_label;
                $attributes_data[$attribute_name]['values'] = wp_list_pluck($terms, 'term_id');
                $attributes_data[$attribute_name]['all_attirbute'] = $GMBPU_GLOBAL['GMBPU_product_all_attributes'][$attribute_name]['values'];

                $defalut_attributes_data[$attribute_name]['istax'] = 'yes';
                $defalut_attributes_data[$attribute_name]['label'] = $attribute_label;
                $defalut_attributes_data[$attribute_name]['values'] = $terms;
                if (isset($default_attributes[$attribute_name])) {
                    $defalut_attributes_data[$attribute_name]['selected'] = $default_attributes[$attribute_name];
                } else {
                    $defalut_attributes_data[$attribute_name]['selected'] = null; // Or set a default value
                }

            } else {
                // If attribute is a custom product attribute
                $attributes_data[$attribute_name]['istax'] = 'no';
                $attributes_data[$attribute_name]['label'] = $attribute->get_name();
                $attributes_data[$attribute_name]['values'] = implode(" | ", $attribute->get_options());

                $defalut_attributes_data[$attribute_name]['istax'] = 'no';
                $defalut_attributes_data[$attribute_name]['label'] = $attribute->get_name();
                $defalut_attributes_data[$attribute_name]['values'] = $attribute->get_options();
                if (isset($default_attributes[$attribute_name])) {
                    $defalut_attributes_data[$attribute_name]['selected'] = $default_attributes[$attribute_name];
                } else {
                    $defalut_attributes_data[$attribute_name]['selected'] = null; // Or set a default value
                }


            }
            $attributes_data[$attribute_name]['visible'] = $attribute->get_visible() ? 'yes' : 'no';  // Is the attribute visible on the product page
            $attributes_data[$attribute_name]['variation'] = $attribute->get_variation() ? 'yes' : 'no';  // Is the attribute used for variations
        }
       // print_r($attributes_data);
        // Convert attributes to JSON
        $json_attributes = $attributes_data;

         return    array(
                    'id' => array(
                        'value' => $product_id
                    ),
                    'name' => array(
                        'value' => $post->post_title
                    ),
                    'slug' => array(
                        'value' => $post->post_name
                    ),
                    '_publish_date' => array(
                        'value' =>  get_the_date('Y-m-d H:i:s', $post)
                    ),
                    '_featured' => array(
                        'value' =>  $product->is_featured()
                    ),
                    '_product_description' => array(
                        'value' => $post->post_content
                    ),
                    '_product_short_description' => array(
                        'value' => $product->get_short_description()
                    ),
                    '_price' => array(
                        'value' => get_post_meta($product_id, '_price', true)
                    ),
                    '_regular_price' => array(
                        'value' => get_post_meta($product_id, '_regular_price', true)
                    ),
                    '_sale_price' => array(
                        'value' => get_post_meta($product_id, '_sale_price', true)
                    ),
                    '_stock_status' => array(
                        'value' => $product->get_stock_status(),
                        'hide' => $product->get_type() === 'variable' ||  $product->get_type() === 'external' ?"yes":"no"
                    ),
                    '_product_type' => array(
                        'value' => $product->get_type()
                    ),
                    '_stock' => array(
                        'value' => $product->get_stock_quantity(),
                        'hide' => $product->get_type() === 'external'?"yes":"no"
                    ),
                    '_sku' => array(
                        'value' => get_post_meta($product_id, '_sku', true)
                    ),
                    '_tax_status' => array(
                        'value' => get_post_meta($product_id, '_tax_status', true)
                    ),
                    '_tax_class' => array(
                        'value' => get_post_meta($product_id, '_tax_class', true)
                    ),
                    '_weight' => array(
                        'value' => get_post_meta($product_id, '_weight', true)
                    ),
                    '_length' => array(
                        'value' => get_post_meta($product_id, '_length', true)
                    ),
                    '_width' => array(
                        'value' => get_post_meta($product_id, '_width', true)
                    ),
                    '_height' => array(
                        'value' => get_post_meta($product_id, '_height', true)
                    ),
                    '_backorders' => array(
                        'value' => get_post_meta($product_id, '_backorders', true)
                    ),
                    '_purchase_note' => array(
                        'value' => get_post_meta($product_id, '_purchase_note', true)
                    ),
                    '_menu_order' => array(
                        'value' =>  $post->menu_order
                    ),
                    '_download_limit' => array(
                        'value' =>  $product->get_download_limit()
                    ),
                    '_download_expiry' => array(
                        'value' =>  $product->get_download_expiry()
                    ),
                    '_virtual' => array(
                        'value' =>  $product->get_virtual()
                    ),
                    
                    '_enable_reviews' => array(
                        'value' => $product->get_reviews_allowed()
                    ),
                    '_sold_individually' => array(
                        'value' => $product->get_sold_individually()
                    ),
                    '_downloadable' => array(
                        'value' => $product->get_downloadable()
                    ),
                    '_manage_stock' => array(
                        'value' => $product->get_manage_stock(),
                        'hide' => $product->get_type() === 'external'?"yes":"no"
                    ),
                    '_status' => array(
                        'value' => $product->get_status()
                    ),
                    '_visibility' => array(
                        'value' => $product->get_catalog_visibility()
                    ),
                    '_product_category' => array(
                        'value' => $product->get_category_ids()
                    ),
                    '_product_tag' => array(
                        'value' => $product->get_tag_ids()
                    ),
                    '_image' => array(
                        'value' => get_post_thumbnail_id($product->get_id())
                    ),
                    '_gallery' => array(
                        'value' => $product->get_gallery_image_ids()
                    ),
                    '_attribute' => array(
                        'value' => $json_attributes
                    ),
                    '_default_attribute' => array(
                        'value' => $defalut_attributes_data,
                        'hide' => $product->get_type() === 'variable'?"no":"yes"
                    ),
                    
                );
    }
}
